/******************************************************************************
 *                       ____    _    _____                                   *
 *                      / ___|  / \  |  ___|    C++                           *
 *                     | |     / _ \ | |_       Actor                         *
 *                     | |___ / ___ \|  _|      Framework                     *
 *                      \____/_/   \_|_|                                      *
 *                                                                            *
 * Copyright 2011-2018 Dominik Charousset                                     *
 *                                                                            *
 * Distributed under the terms and conditions of the BSD 3-Clause License or  *
 * (at your option) under the terms and conditions of the Boost Software      *
 * License 1.0. See accompanying files LICENSE and LICENSE_ALTERNATIVE.       *
 *                                                                            *
 * If you did not receive a copy of the license files, see                    *
 * http://opensource.org/licenses/BSD-3-Clause and                            *
 * http://www.boost.org/LICENSE_1_0.txt.                                      *
 ******************************************************************************/

#ifndef CAF_OTHERS_HPP
#define CAF_OTHERS_HPP

#include <functional>
#include <type_traits>

#include "caf/catch_all.hpp"

namespace caf {

struct others_t {
  constexpr others_t() {
    // nop
  }

  template <class F>
  catch_all<F> operator>>(F fun) const {
    return {fun};
  }
};

constexpr others_t others = others_t{};

} // namespace caf

#endif // CAF_OTHERS_HPP
